unit Player;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, RXSlider, ExtCtrls, MPlayer, Buttons, MMSystem, StdCtrls, Menus,
  RxMenus, RXSwitch;

type
  TPlayForm = class(TForm)
    Panel2: TPanel;
    RxSlider1: TRxSlider;
    PlayImg: TImage;
    NextImg: TImage;
    ForwardImg: TImage;
    BeginImg: TImage;
    EjectImg: TImage;
    EndImg: TImage;
    PlayBtn: TSpeedButton;
    NextBtn: TSpeedButton;
    ForwardBtn: TSpeedButton;
    BeginBtn: TSpeedButton;
    EjectBtn: TSpeedButton;
    EndBtn: TSpeedButton;
    StopImg: TImage;
    StopBtn: TSpeedButton;
    Timer1: TTimer;
    Media1: TMediaPlayer;
    Label1: TLabel;
    Panel1: TPanel;
    RxPopupMenu1: TRxPopupMenu;
    RxSwitch1: TRxSwitch;
    procedure FormResize(Sender: TObject);
    procedure EjectBtnClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure BeginBtnClick(Sender: TObject);
    procedure ForwardBtnClick(Sender: TObject);
    procedure PlayBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure NextBtnClick(Sender: TObject);
    procedure EndBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure RxSlider1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RxSlider1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PlayForm: TPlayForm;

implementation

uses Main;

{$R *.dfm}

procedure TPlayForm.FormResize(Sender: TObject);
begin
RxSlider1.Width:=PlayForm.ClientWidth;
Media1.DisplayRect:= Rect(0, 0, Panel1.Width, Panel1.Height);
end;

procedure TPlayForm.EjectBtnClick(Sender: TObject);
begin
mciSendString('Set cdaudio door closed wait', nil, 0, handle);
end;

procedure TPlayForm.FormShow(Sender: TObject);
begin
try
if MainForm.ListBox1.ItemIndex<>-1 then
begin
Media1.FileName:=MainForm.ListBox1.Items.Strings[MainForm.ListBox1.ItemIndex];
Media1.Open;
Media1.DisplayRect:= Rect(0, 0, Panel1.Width, Panel1.Height);
Media1.Next;
RxSlider1.MaxValue:=Media1.Position;
RxSlider1.Value:=0;
Media1.Previous;
RxSlider1.Tag:=1;
Media1.Play;
end;
except
RxSlider1.Tag:=0;
end;
end;

procedure TPlayForm.BeginBtnClick(Sender: TObject);
begin
try
Media1.Previous;
except
Beep;
end;
end;

procedure TPlayForm.ForwardBtnClick(Sender: TObject);
begin
try
Media1.Back;
except
Beep;
end;
end;

procedure TPlayForm.PlayBtnClick(Sender: TObject);
begin
try
Media1.Close;
Media1.FileName:=Mainform.ListBox1.Items.Strings[MainForm.ListBox1.ItemIndex];
Media1.Open;
Media1.Play;
except
Beep;
end;
end;

procedure TPlayForm.StopBtnClick(Sender: TObject);
begin
try
Media1.Stop;
except
Beep;
end;
end;

procedure TPlayForm.NextBtnClick(Sender: TObject);
begin
try
Media1.Step;
except
Beep;
end;
end;

procedure TPlayForm.EndBtnClick(Sender: TObject);
begin
try
Media1.Next;
except
Beep;
end;
end;

procedure TPlayForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if Media1.FileName<>'' then
Media1.Close;
end;

procedure TPlayForm.Timer1Timer(Sender: TObject);
begin
if RxSlider1.Tag = 1 then begin
if Label1.Caption <> '' then begin
Media1.position :=strtoint(Label1.caption); Label1.Caption:=''; Media1.Play; end;
RxSlider1.Value:=Media1.position;
if RxSlider1.Value=RxSlider1.MaxValue then
begin
if not RxSwitch1.StateOn then
begin
RxSlider1.Value:=0;
Media1.Position:=0;
Media1.play;
exit;
end else
if MainForm.ListBox1.ItemIndex+1=MainForm.ListBox1.Items.count then
begin
MainForm.ListBox1.ItemIndex:=0;
PlayBtn.Click;
end
else
MainForm.ListBox1.ItemIndex:=MainForm.ListBox1.ItemIndex+1;
PlayBtn.Click;
end;
end;
end;
procedure TPlayForm.RxSlider1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
Media1.Stop;
end;

procedure TPlayForm.RxSlider1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
Label1.Caption:=inttostr(RxSlider1.Value);
Media1.Play;

end;
end.

